def main
	Game.caption "Pad Game System 開発中のデモ"
	Sprite.load(:win,"win.png") #これは自前。雑ですが……。
	Sprite.slicenum(:win,3,3)
	Sprite.load(:chr,"chr.png") #「臼井の会」様が公開している画像をお借りしています。
	Sprite.slicenum(:chr,3,4)
	Sprite.load(:mapchip,"tmw_desert_spacing.png")# Tiled map editorのデフォルトのマップチップをお借りしています。
	Sprite.slice(:mapchip,32,32,1,1)#1チップ32x32ドット、周囲に1ドットずつスペースを空けてあるチップなのでそう指定しています。
	map=TiledMap.new(:mapchip)
	map.setdata(64,64,JSON.parse(loadtext("map.json")))#JSONファイルの読み込み
	x=0
	y=0
	anim=Animator.new(:chr,{
		:down=>[[0,10],[1,10],[2,10],[1,10],],
		:left=>[[3,10],[4,10],[5,10],[4,10],],
		:right=>[[6,10],[7,10],[8,10],[7,10],],
		:up=>[[9,10],[10,10],[11,10],[10,10]],
	})#多分この辺はヘルパ関数作ります。ツクール形式のアニメチップ１キャラ分の設定
	anim.set(:down)
	win=Window.new(:win,20,4)
	f=Font.new(16,16,0)

	#一文字ずつ描画
	win.textstart("ながいたびが　はじまる．．",0,0,f)
	while true do
		if win.textnext then break end
		map.draw(x,y,4)
		win.draw(180,200)
		doevents
	end

	#ボタン入力待ち
	while true do
		map.draw(x,y,4)
		win.draw(180,200)
		if Input.getpad(0,Input::A)==2 then break end
		doevents
	end

	#移動。ただし当たり判定も端の処理もしていないので実用ではありません。
	while true do
		map.draw(x,y,8)
		Draw.to(312,232)
		anim.draw()
		vx=Input.getpad(0,Input::VX)
		vy=Input.getpad(0,Input::VY)
		if vx!=0 then vy=0 end
		if x+vx<0 || x+vx>=44*8 || y+vy<0 || y+vy>=49*8 then
			vx=0
			vy=0
		end
		if vx<0 then 
			anim.set(:left)
		elsif vx>0 then
			anim.set(:right)
		elsif vy<0 then
			anim.set(:up)
		elsif vy>0 then
			anim.set(:down)
		end
		if vx==0 && vy==0 then
			anim.pause
		else
			anim.resume
		end
		x=x+vx
		y=y+vy
		doevents
	end
end
